package Pair;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

/**
 * In here you must make firstLast, which will return a pair of the first element in the array list and the last
 * element in the arraylist.
 * You must also make a min method that returns the smallest item in the array list
 * A max method that returns the largest item in the arraylist
 * And a minmax method that returns a pair containing the largest and smallest items from the array list
 */
public class Arrays {
    public static <E extends Comparable<E>> Pair<E> firstLast(ArrayList<E> a) {
        return new Pair<E>((E) a.get(0), (E) a.get(a.size() -1 ));
    }
    public static <E extends Comparable<E>> E min(ArrayList<E> a) {
        E min = null;
        for (E e : a) {
            if (min == null || e.compareTo(min) < 0) {
                min = e;
            }
        }
        return min;
    }
    public static <E extends Comparable<E>> E max(ArrayList<E> a) {
        E max = null;
        for (E e : a) {
            if (max == null || e.compareTo(max) > 0) {
                max = e;
            }
        }
        return max;
    }
    public static <E extends Comparable<E>> Pair<E> minMax(ArrayList<E> a) {
        return new Pair<E>(min(a), max(a));
    }
}
