package StackArray;

import java.lang.reflect.Array;
import java.util.Arrays;

/**
 * Expand the ArrayList implementation of stack here to use an E[] array.  Still implement push, pop, and isEmpty.
 * Remember, you might need to resize the stack in the push method.
 * @param <E>
 */
public class GenericStack<E> {
    private E[] elements;
    int size;

    public GenericStack() {
        elements = (E[]) new Object[10];
        size = 0;
    }

    public void push(E element) {
        if (size >= elements.length) {
            elements = (E[]) Array.newInstance(this.elements.getClass().getComponentType(), elements.length * 3/2);
        }
        elements[size] = element;
        size++;
    }
    public E pop () {
        size--;
        E popped = elements[size];
        elements[size] = null;
        return popped;
    }
    public boolean isEmpty() {
        return size == 0;
    }
}
