package StackArray;

import java.lang.reflect.Array;
import java.util.Arrays;

/**
 * Expand the ArrayList implementation of stack here to use an Object[] array.  Still implement push, pop, and isEmpty.
 * Remember, you might need to resize the stack in the push method.
 * @param <E>
 */
public class ObjectStack<E> {
    private Object[] elements;
    int size;

    public ObjectStack() {
        elements = new Object[10];
        size = 0;
    }

    public void push(Object element) {
        if (size >= elements.length) {
            elements = Arrays.copyOf(this.elements, elements.length * 3/2);
        }
        elements[size] = element;
        size++;
    }
    public Object pop () {
        size--;
        Object popped = elements[size];
        elements[size] = null;
        return popped;
    }
    public boolean isEmpty() {
        return size == 0;
    }
}
